"""Een bedrag gepast betalen met zo min mogelijk euromunten.

   Invoer:
     het bedrag tussen 0 en 500 eurocent
   Uitvoer:
     de minimale betaling met euromunten in tabelvorm
   Restricties:
     er zijn voldoende munten van iedere soort,
     ongebruikte muntsoorten niet vermelden
"""

__author__  = 'Tom Verhoeff (TUE)'
__date__    = '2003/01/04'
__version__ = '2.0'

## Vraag de invoer op.
invoerbedrag = input ( 'Geef bedrag tussen 0 en 500 eurocent: ' )
#@ 0 <= invoerbedrag <= 500

## Doorloop de muntsoorten in dalende volgorde en
## gebruik ze zo vaak mogelijk om het bedrag te passen.
## Schrijf voor elke gebruikte muntsoort een regel in de tabel.

restbedrag = invoerbedrag
geschrevenbedrag = 0

#@ inv: 0 <= restbedrag <= 500
#@      geschrevenbedrag + restbedrag = invoerbedrag

for munt in 200, 100, 50, 20, 10, 5, 2, 1 :
    aantal = 0
    
    #@ inv: geschrevenbedrag + aantal*munt + restbedrag = invoerbedrag
    
    while restbedrag >= munt :  # munt kan (nogmaals) gebruikt worden
        aantal = aantal + 1
        restbedrag = restbedrag - munt
    
    #@ restbedrag < munt, dus munt kan niet (vaker) gebruikt worden
    
    if aantal > 0 :  # munt is inderdaad gebruikt
        print aantal, 'x', munt
        geschrevenbedrag = geschrevenbedrag + aantal*munt

#@ restbedrag = 0, dus invoerbedrag is volledig betaald
