"""Bepaal gemiddelde aantal munten voor minimale betaling met euromunten
   van bedragen tussen twee ingelezen bedragen.

   Invoer:
     minimum en maximum bedrag van interval
   Uitvoer:
     gemiddelde aantal munten in minimale betaling van bedragen in interval
   Restricties:
     minimum en maximum bedrag liggen tussen 1 en 500 eurocent
"""

__author__ = 'Tom Verhoeff (TUE)'

## Definieer constanten
muntsoorten = [ 200, 100, 50, 20, 10, 5, 2, 1 ]  # de euromuntsoorten

## Definieer functies

def betaal ( bedrag ) :
    """Bepaal minimale betaling van bedrag.
       Aanname  : 0 <= bedrag <= 500
                  muntsoorten is globaal gedefinieerde lijst met muntsoorten
                  in dalende volgorde
       Resultaat: lijst met munten voor minimale betaling van bedrag
    """

    betaling = [ ]        #@ inv: betaling tot nu toe opgebouwd
    restbedrag = bedrag   #@ inv: resterende te passen bedrag

    for munt in muntsoorten :
	    aantal, restbedrag = restbedrag / munt, restbedrag % munt
	    betaling.extend ( aantal * [ munt ] )

    return betaling

## Lees invoer
minbedrag, maxbedrag = input ( 'Geef min., max. bedrag tussen 1 en 500: ' )
#@ 1 <= minbedrag <= maxbedrag <= 500

## Bepaal totaal aantal munten in betalingen van bedragen tussen min. en max.
interval = range ( minbedrag, maxbedrag + 1 )
totaal = 0 # totaal aantal munten gebruikt tot nu toe

for bedrag in interval :
    #@ 0 <= bedrag <= 500

    betaling = betaal ( bedrag )
    print '%3d' % bedrag, betaling  # voor testen
    aantalmunten = len ( betaling )
    totaal = totaal + aantalmunten

## Bepaal gemiddelde aantal munten per betaling
gemiddelde = float ( totaal ) / len ( interval )

## Schrijf uitvoer
print 'Gemiddeld aantal munten per betaling: %1.3f' % gemiddelde 

